<template>
  <el-dialog
    width="60%"
    title="erp库存信息"
    top="5vh"
    :visible.sync="innerVisible"
    append-to-body
    @close="$emit('update:currshowlist', false)"
    :show="currshowlist"
    class="part-dialog"
  >
    <el-form
      :model="queryStock"
      :rules="dataRule"
      label-width="120px"
      class="l-mes"
    >
      <el-row>
        <el-col :span="8">
          <el-form-item label="订单号" prop="orderNo">
            <el-input
              v-model="queryStock.orderNo"
              clearable
              placeholder="订单号"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="供应商编号" prop="supplierId">
            <el-input
              v-model="queryStock.supplierId"
              clearable
              placeholder="供应商编号"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="供应商名称" prop="supplierName">
            <el-input
              v-model="queryStock.supplierName"
              clearable
              placeholder="供应商名称"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="8">
          <el-form-item label="零件描述" prop="partDesc">
            <el-input
              v-model="queryStock.partDesc"
              clearable
              placeholder="零件描述"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="零件号" prop="partNo">
            <el-input
              v-model="queryStock.partNo"
              clearable
              placeholder="零件号"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="库位号" prop="locationNo">
            <el-input
              v-model="queryStock.locationNo"
              clearable
              placeholder="库位号"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="8">
          <el-form-item label="批号" prop="lotBatchNo">
            <el-input
              v-model="queryStock.lotBatchNo"
              placeholder="批号"
              clearable
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="wdr号" prop="waivDevRejNo">
            <el-input
              v-model="queryStock.waivDevRejNo"
              placeholder="wdr号"
              clearable
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="3" :offset="2">
          <el-button @click="handleStock">搜索</el-button>
        </el-col>
      </el-row>
    </el-form>
    <el-table
      border
      v-loading="listLoading"
      :data="stockList"
      @selection-change="handleSelectionChange"
      height="600px"
      highlight-current-row
    >
      <!--        @row-dblclick="doubleClick"-->
      <!--        @row-click="rowClick"-->
      <!--        @current-change="handleCurrentChange"-->
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column prop="orderNo" label="订单号"></el-table-column>
      <el-table-column prop="lineNo" label="行号"></el-table-column>
      <el-table-column prop="releaseNo" label="下达号"></el-table-column>
      <el-table-column prop="receiptNo" label="接收号"></el-table-column>
      <el-table-column prop="supplierId" label="供应商编号"></el-table-column>
      <el-table-column prop="supplierName" label="供应商名称"></el-table-column>
      <el-table-column prop="partDesc" label="零件描述"></el-table-column>
      <el-table-column prop="partNo" label="零件号"> </el-table-column>
      <el-table-column prop="locationNo" label="库位号"> </el-table-column>
      <el-table-column prop="lotBatchNo" label="批号"> </el-table-column>
      <el-table-column prop="waivDevRejNo" label="wdr号"> </el-table-column>
      <el-table-column prop="serialNo" label="序列号"> </el-table-column>
      <el-table-column prop="engChgLevel" label="版本号"> </el-table-column>
      <el-table-column prop="qtyArrived" label="数量"> </el-table-column>
    </el-table>
    <span slot="footer" class="dialog-footer">
      <el-button @click="innerVisible = false">取消</el-button>
      <el-button type="primary" v-thinclick="`dataFormSubmit`">确定</el-button>
    </span>
  </el-dialog>
</template>

<script>
export default {
  props: {
    currshowlist: {
      type: Boolean,
      default: false
    },
    multiSelect: {
      type: Boolean,
      default: false
    },
    List: {
      type: Array,
      default: () => {
        return []
      }
    }
  },
  data() {
    return {
      queryStock: {
        partDesc: '',
        partNo: '',
        locationNo: '',
        lotBatchNo: '',
        orderNo: '',
        waivDevRejNo: '',
        supplierId: '',
        supplierName: ''
      },
      stockList: [],
      listLoading: false,
      currentRow: null,
      multipleSelection: [],
      innerVisible: false,
      visible: false,
      dataForm: {
        partNo: '',
        partName: ''
      },
      dataRule: {}
    }
  },
  watch: {
    currshowlist() {
      this.innerVisible = this.currshowlist
      if (this.currshowlist) {
      }
    },
    List: {
      handler(newValue, oldValue) {
        this.initQueryStock()
        this.stockList = []
        this.stockList = newValue
      }
    }
  },
  methods: {
    handleCurrentChange(val) {
      this.currentRow = val
    },
    doubleClick() {
      this.dataFormSubmit()
    },
    initQueryStock() {
      this.queryStock.partNo = ''
      this.queryStock.locationNo = ''
      this.queryStock.lotBatchNo = ''
      this.queryStock.orderNo = ''
      this.queryStock.waivDevRejNo = ''
      this.queryStock.supplierId = ''
      this.queryStock.supplierName = ''
      this.queryStock.partDesc = ''
    },
    rowClick(row) {
      this.currentRow = row
    },
    inputChange(val) {
      const a = JSON.parse(JSON.stringify(this.stockList))
      this.stockList = []
      setTimeout(() => {
        this.stockList = a
      }, 1000)
    },
    // 根据条件搜索erp库存信息数据
    handleStock() {
      this.loadStock()
    },
    loadStock() {
      const newStockList = this.List
      this.stockList = newStockList.filter(
        (x) =>
          (this.queryStock.partDesc == '' ||
          this.queryStock.partDesc == undefined
            ? true
            : x.partDesc
                .toLowerCase()
                .includes(this.queryStock.partDesc.toLowerCase())) &&
          (this.queryStock.partNo == '' || this.queryStock.partNo == undefined
            ? true
            : x.partNo
                .toLowerCase()
                .includes(this.queryStock.partNo.toLowerCase())) &&
          (this.queryStock.locationNo == '' ||
          this.queryStock.locationNo == undefined
            ? true
            : x.locationNo
                .toLowerCase()
                .includes(this.queryStock.locationNo.toLowerCase())) &&
          (this.queryStock.lotBatchNo == '' ||
          this.queryStock.lotBatchNo == undefined
            ? true
            : x.lotBatchNo
                .toLowerCase()
                .includes(this.queryStock.lotBatchNo.toLowerCase())) &&
          (this.queryStock.orderNo == '' || this.queryStock.orderNo == undefined
            ? true
            : x.orderNo
                .toLowerCase()
                .includes(this.queryStock.orderNo.toLowerCase())) &&
          (this.queryStock.waivDevRejNo == '' ||
          this.queryStock.waivDevRejNo == undefined
            ? true
            : x.waivDevRejNo
                .toLowerCase()
                .includes(this.queryStock.waivDevRejNo.toLowerCase())) &&
          (this.queryStock.supplierId == '' ||
          this.queryStock.supplierId == undefined
            ? true
            : x.supplierId
                .toLowerCase()
                .includes(this.queryStock.supplierId.toLowerCase())) &&
          (this.queryStock.supplierName == '' ||
          this.queryStock.supplierName == undefined
            ? true
            : x.supplierName
                .toLowerCase()
                .includes(this.queryStock.supplierName.toLowerCase()))
      )
    },
    handleSelectionChange(val) {
      this.multipleSelection = val
    },
    dataFormSubmit() {
      if (this.multipleSelection.length === 0) {
        this.$message.error('请选择库存信息')
        return
      }
      this.$emit('handleSelectionErpStock', this.multipleSelection)
      this.innerVisible = false
    }
  }
}
</script>
